#ifndef _KILIB_KTL_APTR_H_
#define _KILIB_KTL_APTR_H_
#include "types.h"
#ifdef _MSC_VER
#pragma warning( disable : 4284 ) // xF->̃^[^ɂႤɂ
#pragma warning( disable : 4150 ) // xFdelete̒`ɂ傤ɂ
#endif
#ifndef __ccdoc__
namespace ki {
#endif



//=========================================================================
//@{ @pkg ki.KTL //@}
//@{
//	|C^
//
//	̊҂͈͂ł͊T std::auto_ptr ƓƎvcB
//	ԗւ̍Ŕ΂񂴁[I
//@}
//=========================================================================

template<class T>
class aptr
{
public:

	//@{ RXgN^ //@}
	explicit aptr( T* p = NULL )
		: obj_( p ) {}

	//@{ fXgN^ //@}
	~aptr()
		{ delete obj_; }

	//@{ Lړ //@}
	aptr( aptr<T>& r )
		: obj_ ( r.release() ) {}

	//@{ Lړ //@}
	aptr<T>& operator=( aptr<T>& r )
		{
			if( obj_ != r.obj_ )
			{
				delete obj_;
				obj_ = r.release();
			}
			return *this;
		}

	//@{ Lړ //@}
#ifdef __BORLANDC__
	aptr<T>& operator=( const aptr<T>& r )
		{
			if( obj_ != r.obj_ )
			{
				delete obj_;
				obj_ = const_cast<aptr<T>&>(r).release();
			}
			return *this;
		}
#endif

public:

	//@{ ԐډZq //@}
	T& operator*() const
		{ return *obj_; }

	//@{ oQ //@}
	T* operator->() const
		{ return obj_; }

	//@{ |C^擾 //@}
	T* get() const
		{ return obj_; }

	//@{ L //@}
	T* release()
		{
			T* ptr = obj_;
			obj_ = NULL;
			return ptr;
		}

	//@{ Lǂ //@}
	bool isValid() const
		{
			return (obj_ != NULL);
		}

private:

	mutable T* obj_;
};



//=========================================================================
//@{
//	|C^izŁj
//@}
//=========================================================================

template<class T>
class aarr
{
public:

	//@{ RXgN^ //@}
	explicit aarr( T* p = NULL )
		: obj_( p ) {}

	//@{ fXgN^ //@}
	~aarr()
		{ delete [] obj_; }

	//@{ Lړ ̂bccŏ肭sȂ̂constt //@}
	aarr( const aarr<T>& r )
		: obj_ ( const_cast<aarr<T>&>(r).release() ) {}

	//@{ Lړ //@}
	aarr<T>& operator=( aarr<T>& r )
		{
			if( obj_ != r.obj_ )
			{
				delete [] obj_;
				obj_ = r.release();
			}
			return *this;
		}

public:

	//@{ |C^擾 //@}
	T* get() const
		{ return obj_; }

	//@{ L //@}
	T* release()
		{
			T* ptr = obj_;
			obj_ = NULL;
			return ptr;
		}

	//@{ Lǂ //@}
	bool isValid() const
		{
			return (obj_ != NULL);
		}

private:

	mutable T* obj_;
};



//=========================================================================
//@{
//	폜L|C^
//
//	u\[X̊l̓RXgN^ŁE̓fXgN^Łv
//	OłȂ炱Ȃ̎g킸ɁA킸 const auto_ptr p
//	ׂłBׂłAoXg this gVC++
//	RpCɓ{̂ĈŁAgăRXgN^
//	֐ŏĂ܂̂łӁc(^^;
//@}
//=========================================================================

template<class T>
class dptr
{
public:

	//@{ RXgN^ //@}
	explicit dptr( T* p = NULL )
		: obj_( p ) {}

	//@{ fXgN^ //@}
	~dptr()
		{ delete obj_; }

	//@{ VIuWFNgLBÂ͍̂폜 //@}
	void operator=( T* p )
		{
			delete obj_; // Â͍̂폜
			obj_ = p;
		}

	//@{ Lǂ //@}
	bool isValid() const
		{
			return (obj_ != NULL);
		}

public:

	//@{ ԐډZq //@}
	T& operator*() const
		{ return *obj_; }

	//@{ oQ //@}
	T* operator->() const
		{ return obj_; }

	//@{ |C^擾 //@}
	T* get() const
		{ return obj_; }

private:

	T* obj_;

private:

	NOCOPY(dptr<T>);
};



//=========================================================================
//@{
//	폜L|C^izŁj
//@}
//=========================================================================

template<class T>
class darr
{
public:

	//@{ RXgN^ //@}
	explicit darr( T* p = NULL )
		: obj_( p ) {}

	//@{ fXgN^ //@}
	~darr()
		{ delete [] obj_; }

	//@{ VIuWFNgLBÂ͍̂폜 //@}
	void operator=( T* p )
		{
			delete [] obj_; // Â͍̂폜
			obj_ = p;
		}

	//@{ Lǂ //@}
	bool isValid() const
		{
			return (obj_ != NULL);
		}

public:

	//@{ zvfANZX //@}
	T& operator[]( int i ) const
		{ return obj_[i]; }

private:

	T* obj_;

private:

	NOCOPY(darr<T>);
};



//=========================================================================

#ifdef _MSC_VER
#pragma warning( default : 4150 )
#pragma warning( default : 4284 )
#endif
}      // namespace ki
#endif // _KILIB_KTL_APTR_H_
